/* Copyright (C) |Meso|Star> 2015-2018 (contact@meso-star.com)
 *
 * This software is a computer program whose purpose is to describe a
 * virtual 3D environment that can be ray-traced and sampled both robustly
 * and efficiently.
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software. You can use,
 * modify and/or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty and the software's author, the holder of the
 * economic rights, and the successive licensors have only limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading, using, modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean that it is complicated to manipulate, and that also
 * therefore means that it is reserved for developers and experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and, more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms. */

#ifndef S3D_SCENE_C_H
#define S3D_SCENE_C_H

#include <rsys/hash_table.h>
#include <rsys/list.h>
#include <rsys/ref_count.h>
#include <rsys/signal.h>

/* Generate the htable_shape hash table */
#define HTABLE_NAME shape
#define HTABLE_DATA struct s3d_shape*
#define HTABLE_KEY unsigned /* Id of the shape */
#include <rsys/hash_table.h>

/* Declare the scene_shape_cb_T callback data type */
CLBK(scene_shape_cb_T, ARG2
  (const struct s3d_scene* scn,
   const struct s3d_shape* shape));

struct s3d_scene {
  struct htable_shape shapes; /* List of attached shapes */
  size_t instances_count; /* # instances in the scene */
  struct list_node scnviews; /* Pool of available s3d_scene_view */

  signal_T sig_shape_detach;

  struct s3d_device* dev;
  ref_T ref;
};

#endif /* S3D_SCENE_C_H */

